
.include "low_defs.i"

/********/
/********/

	.align

	.section ".text"
	.type	_init_eth_dm9000,#function
	.globl	_init_eth_dm9000

/********/
/********/
/*
 * EEEE  TTTTT  H  H
 * E       T    H  H
 * EEE     T    HHHH
 * E       T    H  H
 * E       T    H  H
 * EEEE    T    H  H
*/

_portrbase:
	.word 0xf080e800

.macro get_portrbase __reg
	adr \__reg, _portrbase
	ldr \__reg,[\__reg]
.endm

_init_eth_dm9000:

	# Active INTH (the DM9000 external interrupt pin)
	# Configure it as active low, level sensitive
	# INTH is PR2 -> bit2 in the registers
	get_portrbase r0

	# DIR, FR1 and FR2 are default 0 -> ok for INTH

	# GPIORIS (Port Interrupt Selection Register (Level and Edge))
	# [2] PR2IS R/W 0y0 Port R interrupt sensitivity register
	#                   0: Edge-sensitive
	#                   1: Level-sensitive
	# Default is edge sensitive but
	# we want level sensitive
	ldr r1, [r0, #0x04]
	orr r1,r1, #(1<<2)
	str r1, [r0, #0x04]

	# GPIORIE (Port Interrupt Enable Register) Address = (0xF080_E000) +(0x0810)
	#   [2]         PR2IE           R/W       0y0       Port R interrupt enable register
	#                                                   0: Disable
	#                                                   1: Enable
	ldr r1, [r0, #0x10]
	orr r1,r1, #(1<<2)
	str r1, [r0, #0x10]

	mov pc,lr
