
.include "low_defs.i"

/********/
/********/

	.align

	.section ".text"
	.type	_init_mem,#function
	.globl	_init_mem


/*
 * The memory ctrl (MPMC0) controller
*/
.macro get_mpmc0base __reg
	mov \__reg,        #0xF0000000
	add \__reg,\__reg, #0x04000000
	add \__reg,\__reg, #0x00300000
.endm

.set dmc_memc_status_3, 0x0000
.set dmc_memc_cmd_3,    0x0004
.set dmc_direct_cmd_3,  0x0008
.set dmc_memory_cfg_3,  0x000C
.set dmc_refresh_prd_3, 0x0010
.set dmc_cas_latency_3, 0x0014
.set dmc_t_dqss_3,      0x0018
.set dmc_t_mrd_3,       0x001C
.set dmc_t_ras_3,       0x0020
.set dmc_t_rc_3,        0x0024
.set dmc_t_rcd_3,       0x0028
.set dmc_t_rfc_3,       0x002C
.set dmc_t_rp_3,        0x0030
.set dmc_t_rrd_3,       0x0034
.set dmc_t_wr_3,        0x0038
.set dmc_t_wtr_3,       0x003C
.set dmc_t_xp_3,        0x0040
.set dmc_t_xsr_3,       0x0044
.set dmc_t_esr_3,       0x0048
.set dmc_id_0_cfg_3,    0x0100
.set dmc_id_1_cfg_3,    0x0104
.set dmc_id_2_cfg_3,    0x0108
.set dmc_id_3_cfg_3,    0x010C
.set dmc_chip_0_cfg_3,  0x0200
.set dmc_chip_1_cfg_3,  0x0204
.set dmc_chip_2_cfg_3,  0x0208
.set dmc_chip_3_cfg_3,  0x020c
.set dmc_user_config_3, 0x0304

/********/
/********/

#include "dmcconfig.h"






/*
. dmc_user_config_3 (DMC user_config Register)
                                               Address = (0xF430_0000) + (0x0304)

 [31:8]               Undefined Read undefined. Write as zero.
        -          -
 [7]    Reserved      Undefined Read undefined. Write as zero.
                   -
 [6:4]  dmclk_out1 WO 0y000     SDR SDRAM AC setting
                                 must fix to 0y001
[3:1]   Reserved      Undefined Read undefined. Write as zero.
                   -
 [0]    sdr_width  WO 0y0       Set the memory data bus width of
                                corresponding external SDR memory
                                0y0 : 16bit
                                0y1 : 32bit
*/

#if 0
#warning 16bits
_micron_mt48CL16M_6a_userconfigreg:
	.word (0x0 | (0x1 << 4) )
#else
_micron_mt48CL16M_6a_userconfigreg:
	.word (0x1 | (0x1 << 4) )
#endif

_micron_mt48CL16M_6a_chip_0_cfg:
	.word 0x000140FC

_dummy_6a_chip_x_cfg:
	.word 0x000180FF

_init_mem:

	get_mpmc0base r0
	add r0,r0,#(dmc_cas_latency_3-4)

	adr r1,_micron_mt48CL16M_6a_config-4

	@ copy the config to base+0x14 -> +0x48
.rept 14
	ldr	r2, [r1,#4]!
	str r2, [r0,#4]!
.endr

	@ memory config
	get_mpmc0base r0
	ldrsym r1, _micron_mt48CL16M_6a_memconfreg
	str r1, [r0, #dmc_memory_cfg_3]

	@ user config
	ldrsym r1, _micron_mt48CL16M_6a_userconfigreg
	str r1, [r0, #dmc_user_config_3]

	@ this is the default one in the TMPA doc
	ldrsym r1, _micron_mt48CL16M_6a_autorefresh
	str r1, [r0, #dmc_refresh_prd_3]

	@ CS to 0x40000000
	ldrsym r1, _micron_mt48CL16M_6a_chip_0_cfg
	str r1, [r0, #dmc_chip_0_cfg_3]

	ldrsym r1, _dummy_6a_chip_x_cfg
	str r1, [r0, #dmc_chip_1_cfg_3]
	str r1, [r0, #dmc_chip_2_cfg_3]
	str r1, [r0, #dmc_chip_3_cfg_3]

	@ controller init done
	@ issue now memory chip init

.macro initone __chip2init
	@ NOP
	mov r1,#\__chip2init
	add r1,#0xc0000
	str r1, [r0, #dmc_direct_cmd_3]

	@ Precharge all
	mov r1,#\__chip2init
	add r1,#0x00000
	str r1, [r0, #dmc_direct_cmd_3]


	@ Autorefresh
	mov r1,#\__chip2init
	add r1,#0x40000
	str r1, [r0, #dmc_direct_cmd_3]
	str r1, [r0, #dmc_direct_cmd_3]

	@ Write the mode reg register from the memory chip
	@ burst=2 -> 00 0000 0000 0001
	@ CAS  =3 -> 00 0000 0011 0000
	mov r1,#\__chip2init
	orr r1,#0x00001 // BL
	orr r1,#0x00030
	orr r1,#0x80000
	str r1, [r0, #dmc_direct_cmd_3]

.endm

	initone 0x000000

	get_mpmc0base r0

	mov r1,#0x5
	str r1, [r0, #dmc_id_0_cfg_3]
	str r1, [r0, #dmc_id_1_cfg_3]
	str r1, [r0, #dmc_id_3_cfg_3]

	mov r1,#0xb
	str r1, [r0, #dmc_id_2_cfg_3]

	// Enable the controller
	// change the state from config to ready
	get_mpmc0base r0
	mov r1,#0
	str r1, [r0, #dmc_memc_cmd_3]



	mov pc,lr

