
.include "low_defs.i"

/********/
/********/

	.align

	.section ".text"
	.type	_init_i2s,#function
	.globl	_init_i2s

/*
 * I  2222  SSSS
 * I     2  S 
 * I  2222  SSSS
 * I  2        S
 * I  2222  SSSS
 *
*/
_portmbase:
	.word 0xf080b400

.macro get_portmbase __reg
	adr \__reg, _portmbase
	ldr \__reg,[\__reg]
.endm

_i2s_base:
	.word 0xf2040000

.macro get_i2s_base __reg
	adr \__reg, _i2s_base
	ldr \__reg,[\__reg]
.endm

.set I2S_TMS, 		0x0c
.set I2S_STMCON,	0x10
.set I2S_COMMOM,  0x44

.set I2S_TCON,  	0x0

_init_i2s:

	get_i2s_base r0

	// mute TX
	mov r1,# ( (1 << 12) | (1 << 13) ) 
	str r1, [r0, #I2S_TCON]

	// prepare an almost 24Khz freq
	// MCKL = Source/4, and WS = MCLK/256
	mov r1,#0x08 
	str r1, [r0, #I2S_STMCON]

	// source clock fron fosch
	mov r1,#0x08 
	str r1, [r0, #I2S_COMMOM]

	// Master
	mov r1,#0x01
	str r1, [r0, #I2S_TMS]

	// Switch to the correct function
	// once the I2s device is quiet
	get_portmbase r0

	// On reset the pin ar GPIO input
	// port M in I2S mode
	mov r1,#0x0F
	str r1, [r0, #GPIONFR1]

	mov pc,lr

