
.include "low_defs.i"

/********/
/********/

	.align

	.section ".text"
	.type	_init_ts,#function
	.globl	_init_ts

	.type	_init_ios,#function
	.globl	_init_ios

	.type	_init_spi,#function
	.globl	_init_spi

/********/
/********/
.macro get_portnbase __reg
	mov \__reg,        #0xF0000000
	add \__reg,\__reg, #0x00800000
	add \__reg,\__reg, #0x0000c400
.endm


/********/
/********/

/*
 * TTTTT SSSS
 *   T   S 
 *   T   SSSS
 *   T      S
 *   T   SSSS
 *
*/
_portd_fr_base:
	.word 0xf0803400

.macro get_portd_fr_base __reg
	adr \__reg, _portd_fr_base
	ldr \__reg,[\__reg]
.endm


_init_ts:
	get_portd_fr_base r0

	// Port D for TS
	mov r1,#0x00
	str r1, [r0, #GPIONFR1]

	mov r1,#0xf0
	str r1, [r0, #GPIONFR2]

	mov pc,lr

/********/
/********/

/*
 * I   OO
 * I  O  O
 * I  O  O
 * I  O  O
 * I   OO
 *
*/

_init_ios:
	get_portnbase r0

	// port N as UART
	// funcion 3
	mov r1,#0xFD
	str r1, [r0, #GPIONFR1]

	mov r1,#0x02
	str r1, [r0, #GPIONFR2]

	mov pc,lr


/********/
/********/

/*
 * SSSS  PPPP  I
 * S  O  P  P  I
 * SSSS  PPPP  I
 *    S  P     I
 * SSSS  P     I
 *
*/
_portf_fr_base:
	.word 0xF080F400

.macro get_portf_fr_base __reg
	adr \__reg, _portf_fr_base
	ldr \__reg,[\__reg]
.endm


_init_spi:

	mov pc,lr
