
.include "low_defs.i"

/********/
/********/

	.align

	.section ".text"
	.type	_init_smc0,#function
	.globl	_init_smc0

/********/
/********/

/*
 *  SSS  M M   CCC
 * S    M M M C
 * S    M M M C
 *  SSS M M M C
 *    S M M M C
 * sSSS M M M  CCC
*/

/***/
_smc_cs1_cycles:
	# Trc=10, Tceoe=7, Ttr=2, Twc=10, Twp=2
	.word (0xa | (0xa<<4) | (0x7<<8) | (0x5<<11) | (0x2<<14) | (0x2<<17) )

_smc_cs1_mode:
	# 32bits, async read and write, no smc_adv
	.word (0x2)

_smc0base:
	.word 0xf4301000

.macro get_smc0base __reg
	adr \__reg, _smc0base
	ldr \__reg,[\__reg]
.endm

_init_smc0:
	get_smc0base r0

	# Write the "write reg"
	ldrsym r1, _smc_cs1_cycles
	str r1, [r0, #0x14]

	ldrsym r1, _smc_cs1_mode
	str r1, [r0, #0x18]

	# Ack the value for CS1
	mov r1,#0xc00000
	str r1, [r0, #0x10]

	mov pc,lr

